<template>
  <div>
    <p v-if="!sourcesConfigured">
      {{ t("Please configure sources in the settings") }}
    </p>
    <table v-for="record in recordsSorted" :key="record.id" class="todo__table">
      <caption class="todo__list-name">
        {{
          record.name
        }}
      </caption>
      <tbody>
        <tr v-for="(reminder, idx) in record.reminders" :key="idx">
          <td>{{ reminder.completed ? "✔︎" : "○" }}</td>
          <td>
            {{ reminder.summary }}
            <span v-if="reminder.assignee" class="todo__assignee">{{
              reminder.assignee
            }}</span>
          </td>
          <td>
            {{ reminder.due_date ? formatDueDate(reminder.due_date) : null }}
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
module.exports = {
  name: "todos",
  props: {
    currentSettings: {
      type: Object,
      required: true,
      default: function () {
        return {
          sort: "created"
        }
      }
    },
    currentDimensions: {
      type: Object,
      required: false
    },
    sourcesConfigured: {
      type: Boolean,
      required: false
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  dueDateOptions: {
    day: "2-digit",
    month: "2-digit",
    year: "2-digit"
  },
  computed: {
    recordsSorted: function() {
      // Guard against incomplete data
      if (this.records.length === 0) return {};

      return this.records.map(record => {
        // Copy reminders for sorting so we don't mess with reactive objects
        const copy = Object.assign([], record.attributes.reminders);
        let reminders;
        switch (this.currentSettings.sort) {
          case "created":
          default:
            reminders = copy.reverse();
            break;
          case "created_reverse":
            reminders = copy; // Default sort order from backend
            break;
          case "alphabetical":
            reminders = copy.sort((a, b) =>
              a.summary.localeCompare(b.summary, this.language)
            );
            break;
          case "alphabetical_reverse":
            reminders = copy
              .sort((a, b) => a.summary.localeCompare(b.summary, this.language))
              .reverse();
            break;
        }
        return {
          name: record.attributes.name,
          // Row height is 26px, list title is 24 px.
          reminders: reminders.slice(
            0,
            Math.floor((this.currentDimensions.heightPx - 24) / 26)
          )
        };
      });
    }
  },
  methods: {
    formatDueDate(date) {
      return new Intl.DateTimeFormat(this.language, this.$options.dueDateOptions).format(
        Date.parse(date)
      );
    }
  },
  locales: {
    deDe: {
      "Please configure sources in the settings":
        "Bitte konfiguriere Datenquellen in den Einstellungen"
    },
    frFr: {
      "Please configure sources in the settings":
        "Veuillez configurer les sources dans les paramètres"
    },
    esEs: {
      "Please configure sources in the settings":
        "Por favor, configure las fuentes en la configuración."
    },
    plPl: {
      "Please configure sources in the settings":
        "Skonfiguruj źródła w ustawieniach"
    },
    koKr: {
      "Please configure sources in the settings":
        "설정에서 소스를 구성하십시오."
    }
  }
};
</script>
<style scoped>
.todo__list-name {
  font-weight: 700;
  text-align: left;
}

.todo__table td {
  vertical-align: top;
}

.todo__assignee {
  font-size: 0.8rem;
  display: block;
}
</style>
